package cn.tedu.shoot;
import java.awt.image.BufferedImage;
/** Ӣۻ: Ƿ */
public class Hero extends FlyingObject {
	private int life;       //
	private int doubleFire; //ֵ
	private BufferedImage[] images; //ͼƬ
	private int index; //ЭͼƬл
	/** 췽 */
	public Hero(){
		image = ShootGame.hero0; //ͼƬ
		width = image.getWidth();	//
		height = image.getHeight(); //
		x = 150; //̶x
		y = 400; //̶y
		life = 3; //Ĭ3
		doubleFire = 0; //ĬΪ0()
		images = new BufferedImage[]{ShootGame.hero0,ShootGame.hero1}; //ͼƬл
		index = 0; //Эл
	}

	/** дstep()һ */
	public void step(){ //10һ
		image = images[index++/10%images.length]; //ÿ100лһ
		
		/*
		//ÿ100лһ
		index++;
		int a = index/10;
		int b = a%2;
		image = images[b];
		*/
		/*
		 * 10M  index=1  a=0 b=0
		 * 20M  index=2  a=0 b=0
		 * 30M  index=3  a=0 b=0
		 * ...
		 * 100M index=10 a=1 b=1
		 * 110M index=11 a=1 b=1
		 * ...
		 * 200M index=20 a=2 b=0
		 * ...
		 * 300M index=30 a=3 b=1
		 */
	}

	/** Ӣۻӵ(ӵ) */
	public Bullet[] shoot(){
		int xStep = this.width/4; //1/4ӢۻĿ
		int yStep = 20; //̶ֵ
		if(doubleFire>0){ //˫
			Bullet[] bs = new Bullet[2];
			bs[0] = new Bullet(this.x+1*xStep,this.y-yStep); //x:Ӣۻx+1/4ӢۻĿ y:Ӣۻy-20
			bs[1] = new Bullet(this.x+3*xStep,this.y-yStep); //x:Ӣۻx+3/4ӢۻĿ y:Ӣۻy-20
			doubleFire-=2; //һ˫ֵ2
			return bs;
		}else{ //
			Bullet[] bs = new Bullet[1];
			bs[0] = new Bullet(this.x+2*xStep,this.y-yStep); //x:Ӣۻx+2/4ӢۻĿ y:Ӣۻy-20
			return bs;
		}
	}
	
	/** Ӣۻƶ  x,y:xy */
	public void moveTo(int x,int y){
		this.x = x-this.width/2;  //Ӣۻx=x-1/2ӢۻĿ
		this.y = y-this.height/2; //Ӣۻy=y-1/2Ӣۻĸ
	}
	
	/** дoutOfBounds()Խ */
	public boolean outOfBounds(){
		return false; //Խ
	}
	
	/** Ӣۻ */
	public void addLife(){
		life++; //1
	}
	
	/** ȡӢۻ */
	public int getLife(){
		return life; //
	}
	
	/** Ӣۻ */
	public void subtractLife(){
		life--; //1
	}
	
	/** Ӣۻ */
	public void addDoubleFire(){
		doubleFire+=40; //ֵ40
	}
	
	/** ջֵ */
	public void clearDoubleFire(){
		doubleFire = 0; //ֵ 
	}
	
	/** Ӣۻ˵ײ  this:Ӣۻ other: */
	public boolean hit(FlyingObject other){
		int x1 = other.x-this.width;   //x1:˵x-ӢۻĿ
		int x2 = other.x+other.width;  //x2:˵x+˵Ŀ
		int y1 = other.y-this.height;  //y1:˵y-Ӣۻĸ
		int y2 = other.y+other.height; //y2:˵y+˵ĸ
		int x = this.x;				   //x:Ӣۻx
		int y = this.y;                //y:Ӣۻy
		
		return x>=x1 && x<=x2
			   &&
			   y>=y1 && y<=y2; //xx1x2֮䣬ңyy1y2֮䣬Ϊײ
	}
	
}













